#!/usr/bin/env python2.7
# -*- coding: utf-8 -*-
'''
Name: conky_SetStyle.py
Created: 2012-01-08
Last Updated: 2012-07-11

Change the transparency of the conky background image depending on the current background image set by feh

Changelog
v1.4 2012-07-11
	output bglog for reading by lua script
	
v1.3 2012-05-13
	use python to write background shadeing image instead of octave
	
v1.2 2012-05-06
	add ability to change roxterm transparency
	
v1.1 2012-05-01
	log current bg transparency and background filename to file for display in conky
	
v1.0 2012-01-08
'''
from subprocess import Popen, PIPE
#from PIL import Image

#### User Defined variables ####
homePath = '' # full path to home directory (ex. no "~") or full path to .fehbg if not in home directory
outputPath = '' # full path to directory to output the file to
logPath = ''
bgName = 'dynamic_background.png' # name of the image file to create (must be .png or .tiff for transparency)
outputString = outputPath + bgName # make full output string for use later
"""
Red = 47 # 8bit red value (0-255)
Green = 79 # 8bit green value (0-255)
Blue = 79 # 8 bit blue value (0-255)
alphaAmountDefault = 0.3 # default alpha transparency amount in percent for undefined backgrounds (0.0-1.0)
roxtermAlpha = 0.48 # default roxterm transparency amount (0.0-0.999999)
"""
defaultStyle = "47|79|79|0.3|0.48" #bgRed|bgGreen|bgBlue|bgAlpha|roxtermAlpha
# define transparency amount for backgrounds by file name
definedBackgrounds = {
"background_filename.png":"47|79|79|1.0|0.8|0.7"
}
#### End User Defined Variables ####
fehBG_Log = open((homePath + '.fehbg'),'r')
print "Number Backgrounds = " + str(len(definedBackgrounds))
currentBackground = fehBG_Log.read().strip().split("'")[1].split("/")[-1]
print currentBackground
fehBG_Log.close()
setStyle = definedBackgrounds.get(currentBackground, defaultStyle).split("|") # use dictionary of definedBackgrounds to deterine the amount of transparency for this background. If the background is not in the dictionary use the default alpha value.
if setStyle == defaultStyle.split("|"):
	print "Using Default Style"
#endif
print str(setStyle)
##### if using background image ####
#newBG = Image.new('RGBA',(1,1),(int(setStyle[0]),int(setStyle[1]),int(setStyle[2]),(int((float(1) - float(setStyle[3]))*float(256)))))
#newBG.save(outputString,"png")
##### if using lua background ######
luaBG = "return {" + str(int(setStyle[0])/255) + "," + str(int(setStyle[1])/255) + "," + str(int(setStyle[2])/255) + "," + str(float(1) - float(setStyle[3])) + "}"
luaBGLog = open((outputPath + "currentBGLua_log.txt"),"w")
luaBGLog.write(luaBG)
luaBGLog.close()
######
(stdout, stderr) = Popen(["dbus-send", "--session", "/net/sf/roxterm/Options", "net.sf.roxterm.Options.FloatOption", "string:Profiles/Test", "string:saturation", ("double:" + setStyle[4])], stdout=PIPE, stderr=PIPE).communicate() # change roxterm transparency
if stdout != "":
	print "roxterm stdout = " + str(stdout)
#endif
if stderr != "":
	print "roxterm stderr " + str(stderr)
#endif
#####################
currentBGlog = open((logPath + "currentBG_log_lua.txt"),'w')
currentBGlog.write(setStyle[4] + "\n" + setStyle[3] + "\n" + currentBackground)
currentBGlog.close()
