#!/usr/bin/env python2.7
# -*- coding: utf-8 -*-
"""
updateCheck_conky.py
created:2011-11-10
last Update:2012-08-14
		
python script to check if there are available updates

Changelog
v2.3 2012-08-14
  update for scrolling ouput

v2.2 2012-07-10
  also handle "E: Some index files failed to download ..." error
  
v2.1 2012-07-10
  output for displaying with lua script

v2.0 2012-05-29
  Add list of packages that will be upgraded to output
"""

from subprocess import Popen, PIPE
import sys
import time

outputFile = ""

while True:
	timeStart = time.time()
	print "First Update Try -- Debug"
	(stdout, stderr) = Popen(["sudo","apt-get","update"], stdout=PIPE, stderr=PIPE).communicate() # update packages list
	print "update1"
	if stderr != "":
		print "stderr1 = " + stderr
	#endif
	reupdateTest = stdout.split("/n")
	if (reupdateTest[len(reupdateTest)-1].strip() == "W: You may want to run apt-get update to correct these problems") or (stderr.find("E: Some index files failed to download. They have been ignored, or old ones used instead.") != (-1)): # update again if there are  duplicate packages
		print "Second Update Try -- Debug"
		(stdout, stderr) = Popen(["sudo","apt-get","update"], stdout=PIPE, stderr=PIPE).communicate() # update packages list again
		if stderr != "":
			print "stderr2 = " + stderr
		#endif
		print "update2"
	#endif
	print "Check For Upgrades -- Debug"
	(stdout, stderr) = Popen(["sudo","apt-get","-q","-y","--allow-unauthenticated","-s","dist-upgrade"], stdout=PIPE, stderr=PIPE).communicate() # check for updates with apt-get (simuated install)
	if stderr != "":
		print "stderr3 = " + stderr
	#endif
	stdoutString = stdout.split("\n")
	updateStatusFound = False
	updatedPackagesList = False
	packagesListStart = False
	firstLineRead = False
	packagesToBeUpdated = ""
	packagesToBeUpdated_Conky = ""
	updateStringLua = "return { {"
	try:
		for currentLine in stdoutString:
			if currentLine.strip() == "The following packages will be upgraded:":
				updatedPackagesList = True # the start of the list of packages that will be updated has been found
			elif updatedPackagesList == True:
				packagesListStart = True	
			#endif
			currentLineSplit = currentLine.split(" ")
			if currentLineSplit[1] == "upgraded,":
				for i in xrange(len(currentLineSplit)):
					if (currentLineSplit[i] == "upgraded," or currentLineSplit[i] == "newly" or currentLineSplit[i] == "installed," or currentLineSplit[i] == "downgraded," or currentLineSplit[i] == "to" or currentLineSplit[i] == "remove" or currentLineSplit[i] == "and" or currentLineSplit[i] == "not" or currentLineSplit[i] == "upgraded."):
						updateStringLua += '"' + currentLineSplit[i] + '",'
					else:
						updateStringLua += currentLineSplit[i] + ','
					#endif
				#endfor
				currentTime = time.time() # the current time
				currentTime_String = time.strftime('"%H:%M",' ,time.localtime(float(currentTime))) # convert epoch to localtime
				nextUpdateTime = time.strftime('"%H:%M"} , ' ,time.localtime(float(currentTime) + float(1800))) # convert epoch to localtime
				updateStringLua += currentTime_String + nextUpdateTime
				packagesListStart = False # packages list has ended
				updateStatusFound = True 
				updateString = currentLine.strip()
				break
			elif packagesListStart == True:
				if firstLineRead == True:
					packagesToBeUpdated = packagesToBeUpdated + currentLine.strip() + "\n"
					packagesToBeUpdated_Conky = packagesToBeUpdated_Conky + " " + currentLine.strip()
				else:
					packagesToBeUpdated = packagesToBeUpdated + currentLine.strip()
					packagesToBeUpdated_Conky = packagesToBeUpdated_Conky + " " + currentLine.strip()
					firstLineRead = True
			#endif
		#endfor	
		print ""
		print "To Be Updated"
		print packagesToBeUpdated.strip()
		print updateString
		updateStringLua += '"' + packagesToBeUpdated_Conky.strip(" ") + '" }'
		logf = open(outputFile, 'w') # write updateCheck data to file
		logf.write(updateStringLua)
		logf.close()
		timeEnd = time.time()
		timeDiff = timeEnd - timeStart
		if timeDiff < 1800 and timeDiff > 0:
			time.sleep(1800 - timeDiff)
		#endif
	except IndexError:
		print "Index Error"
		time.sleep(900)	
	#endtry	
#endwhile
